%define		blist_ver 20051119
%define		ver 1.4
Summary:	Filter, redirector and access controller plugin for Squid
Summary(pl.UTF-8):	Wtyczka z filtrem, przekierowywaniem i kontrolerem dostępu dla Squida
Name:		squidGuard
Version:	%{ver}_%{blist_ver}
Release:	4
Epoch:		2
License:	GPL
Group:		Networking/Daemons
Source0:	http://squidguard.org/Downloads/squidGuard-%{ver}.tar.gz
# Source0-md5:	de834150998c1386c30feae196f16b06
Source1:	%{name}.conf
Source2:	ftp://ftp.teledanmark.no/pub/www/proxy/squidGuard/contrib/blacklists-%{blist_ver}.tar.gz
# Source2-md5:	7ebb53ea33459c14cbc850cd73405915
# http://www.squidguard.org/Downloads/Patches/1.4/squidGuard-1.4-patch-20091015.tar.gz
Patch0:		%{name}-long-urls-buffer-overflow.patch
Patch1:		%{name}-url-bypass.patch
URL:		http://www.squidguard.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	db-devel
BuildRequires:	flex
BuildRequires:	gettext-devel
BuildRequires:	libtool
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post):	grep
Requires(post,preun):	squid
Requires(postun):	sed >= 4.0
Requires:	squid
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/%{name}
%define		_datadir	%{_sysconfdir}

%description
SquidGuard is a combined filter, redirector and access controller
plugin for Squid. It is free, very flexible, extremely fast, easily
installed, portable. SquidGuard can be used to:
- limit the web access for some users to a list of accepted/well known
  web servers and/or URLs only,
- block access to some listed or blacklisted web servers and/or URLs
  for some users,
- block access to URLs matching a list of regular expressions or words
  for some users,
- enforce the use of domainnames/prohibit the use of IP address in
  URLs,
- redirect blocked URLs to an "intelligent" CGI based info page,
- redirect unregistered user to a registration form,
- redirect popular downloads like Netscape, MSIE etc. to local copies,
- redirect banners to an empty GIF,
- have different access rules based on time of day, day of the week,
  date etc,
- have different rules for different user groups.

Neither squidGuard nor Squid can be used to:
- filter/censor/edit text inside documents,
- filter/censor/edit embeded scripting languages like JavaScript or
  VBscript inside HTML.

%description -l pl.UTF-8
SquidGuard jest wtyczką dla Squida będącą połączonym filtrem,
przekierowywaniem i kontrolerem dostępu. Jest darmowy, elastyczny,
bardzo szybki, łatwo instalowalny, przenośny. Może być używany do:
- ograniczenia dostępu do WWW dla niektórych użytkowników na podstawie
  listy akceptowanych serwerów lub URL-i,
- blokowania dostępu do niektórych serwerów lub URL-i dla niektórych
  użytkowników,
- blokowania dostępu do URL na podstawie wyrażeń regularnych lub słów
  dla niektórych użytkowników,
- narzucenia używania nazw domen/zabronienia używania adresów IP w
  URL-ach,
- przekierowania zablokowanych URL-i na "inteligentną" stronę
  informacyjną w CGI,
- przekierowania niezarejestrowanych użytkowników do formularza
  rejestracyjnego,
- przekierowania ściągania popularnego oprogramowania (Netscape, MSIE)
  na lokalne kopie,
- przekierowania bannerów na puste GIF-y,
- uzależnienia reguł dostępu w zależności od pory dnia, dnia tygodnia,
  daty itp.,
- różnych reguł dostępu dla różnych grup użytkowników.

Natomiast ani squidGuard ani Squid nie może być użyty do:
- filtrowania/cenzurowania/edycji tekstu wewnątrz dokumentu,
- filtrowania/cenzurowania/edycji osadzonych w HTML skryptów
  (JavaScript, VBscript...)

%prep
%setup -q -n %{name}-%{ver}
%patch0 -p1
%patch1 -p1

%build
%{__libtoolize}
%{__gettextize}
%{__aclocal}
%{__autoconf}
%configure \
	--with-sg-logdir=/var/log/%{name} \
	--with-sg-config=%{_sysconfdir}/squidGuard.conf \
	--with-sg-dbhome=%{_sysconfdir}/db \
	--with-db=%{_prefix}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/var/log/%{name},%{_bindir}} \
	$RPM_BUILD_ROOT%{_sysconfdir}/db/{advertising,bannedsource,banneddestination} \
	$RPM_BUILD_ROOT%{_sysconfdir}/db/{timerestriction,lansource,privilegedsource}

install src/squidGuard $RPM_BUILD_ROOT%{_bindir}

touch $RPM_BUILD_ROOT%{_sysconfdir}/db/advertising/{domains,urls}
touch $RPM_BUILD_ROOT%{_sysconfdir}/db/banneddestination/{domains,urls,expressions}
touch $RPM_BUILD_ROOT%{_sysconfdir}/db/bannedsource/ips
touch $RPM_BUILD_ROOT%{_sysconfdir}/db/lansource/lan
touch $RPM_BUILD_ROOT%{_sysconfdir}/db/timerestriction/lan
touch $RPM_BUILD_ROOT%{_sysconfdir}/db/privilegedsource/ips

touch $RPM_BUILD_ROOT/var/log/%{name}/%{name}.{log,error}

tar zxf %{SOURCE2} -C $RPM_BUILD_ROOT%{_sysconfdir}/db
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}
rm -rf samples/dest

rm -f $(find $RPM_BUILD_ROOT%{_sysconfdir}/db -name *diff -type f)

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ -f /etc/squid/squid.conf ] && \
	! grep -q "^redirect_program.*%{_bindir}/%{name}" /etc/squid/squid.conf; then
	echo "redirect_program %{_bindir}/squidGuard -c /etc/squidGuard/squidGuard.conf" >>/etc/squid/squid.conf
	%service -q squid reload
fi

%preun
if [ -f /etc/squid/squid.conf ]; then
	%{__sed} -i -e /^redirect_program.*%(echo %{_bindir}/%{name} | sed -e 's,/,\\/,g')/d' /etc/squid/squid.conf
	#' spec.vim sucks
	%service -q squid reload
fi

%files
%defattr(644,root,root,755)
%doc README ANNOUNCE samples/* doc/*.{html,gif,txt}
%doc contrib/{squidGuardRobot/{squidGuardRobot,RobotUserAgent.pm},sgclean/sgclean,hostbyname/hostbyname}
%attr(755,root,root) %{_bindir}/*
%attr(750,root,squid) %dir %{_sysconfdir}
%attr(640,root,squid) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/squidGuard.conf
%{_sysconfdir}/db
%attr(770,root,squid) %dir /var/log/%{name}
%attr(640,squid,squid) %ghost /var/log/%{name}/*
%changelog
* Wed Sep 05 2012 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/squidGuard.git;a=log;h=master

* Wed Sep 05 2012 Jan Rękorajski <baggins@pld-linux.org> fd38c3f
- release 4 (by relup.sh)

* Tue Sep 04 2012 Jan Rękorajski <baggins@pld-linux.org> 6cb0107
- Rebuild with DB 5.3
- release 3 (by relup.sh)

* Tue Feb 16 2010 Adam Gołębiowski <adamg@pld-linux.org> 14b72a2
- release 2

* Tue Feb 16 2010 Adam Gołębiowski <adamg@pld-linux.org> 5bb5e39
- new (based on http://www.squidguard.org/Downloads/Patches/1.4/squidGuard-1.4-patch-20091019.tar.gz)

* Tue Feb 16 2010 Adam Gołębiowski <adamg@pld-linux.org> 3438eb6
- new (based on http://www.squidguard.org/Downloads/Patches/1.4/squidGuard-1.4-patch-20091015.tar.gz)

* Tue Feb 16 2010 Adam Gołębiowski <adamg@pld-linux.org> 53b6039
- drop obsolete patches
- two new patches, based on official ones

* Tue Feb 16 2010 Adam Gołębiowski <adamg@pld-linux.org> a5cfe7c
- obsolete

* Sun Jan 25 2009 Adam Gołębiowski <adamg@pld-linux.org> 88ecdda
- updated to 1.4

* Mon Sep 29 2008 areq <areq@pld-linux.org> 624ba14
- 1.4beta

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 79370b1
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 5cfb6de
- converted to UTF-8

* Fri May 19 2006 Elan Ruusamäe <glen@pld-linux.org> 67fb056
- use %service
- use sed for inline edits
- drop non cvslog changelog
- rel 2

* Fri Apr 21 2006 Jan Rękorajski <baggins@pld-linux.org> 701f4b4
- orphaned, outdated

* Sun Jun 05 2005 Sławomir Paszkiewicz <paszczus@pld-linux.org> 4bc119e
- updated blacklist to 20050604 ; STBR

* Wed May 18 2005 Jakub Bogusz <qboosh@pld-linux.org> 83f4c9d
- gpm-friendly Source URLs, sorted verify() flags

* Wed Mar 23 2005 Tomasz Pala <gotar@pld-linux.org> a30c8fb
- %desc

* Mon Jan 03 2005 Sławomir Paszkiewicz <paszczus@pld-linux.org> d4317ad
- updated blist to 20050101

* Mon Jan 03 2005 Andrzej Zawadzki <zawadaa@gmail.com> 0efbdfe
- ech.. rel. up to 3
- STBR

* Mon Jan 03 2005 Andrzej Zawadzki <zawadaa@gmail.com> 46dea48
- for build squidGard with db4

* Mon Jan 03 2005 Andrzej Zawadzki <zawadaa@gmail.com> 7d68403
- patches for build with db4 from Tomasz Kolaj migo at abp.pl

